#!/usr/bin/python

import struct
import sys
import os

class optfile:

  dict = {'key':'value'}
  
  def __init__(self,filename):
    fn = filename
    lf = open( fn, "rb" )
    self.get_dict( lf )
    
  def get_2_bytes(self,lf):
    c = [0x5,0x4,0x7,0x6,0x1,0x0,0x3,0x2,0xd,0xc,0xf,0xe,0x9,0x8,0xb,0xa]

    i = lf.tell()
    bytes = lf.read(2)
    x = 0
    x = struct.unpack('<H', bytes)[0]
    y = 0
    y = c[i & 0xf]+(c[(i>>4) & 0xf]<<4)+(c[(i>>8) & 0xf]<<8)+(c[(i>>12) & 0xf]<<12)
    return x^y

  def get_4_bytes(self,lf):
    return self.get_2_bytes(lf)+(self.get_2_bytes(lf)<<16)
    
  def get_dict(self,lf): 
    lf.seek(0x2022)
    tb = self.get_4_bytes(lf)
    i = 0x202a
    while i<tb:
      lf.seek(i)
      addr = self.get_4_bytes(lf)
      strl = self.get_4_bytes(lf)
      keyl = self.get_4_bytes(lf)
      j = 0
      key = ''
      while j<keyl:
        bytes = self.get_2_bytes(lf)
        key += unichr(bytes)
        j=j+1
      
      lf.seek(addr)
      j = 0
      line = ''
      while j<strl:
        bytes = self.get_2_bytes(lf)
        line += unichr(bytes)
        j=j+1
      line = line.strip()
      line = line.strip('\n')
      self.dict[key] = line 
      i=i+12+keyl*2

if __name__ == "__main__":
  of = optfile("../EcuRenault/Sessions/SG0110016.XML")
  for k in of.dict.keys():
    print k
    #print of.dict[k]
